% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Two.II\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
Consider the correspondence given in the text between $\N$
and $\set{0,1}\times \N$.
\begin{equation*}
  \begin{array}{r|cccccc@{\hspace{6pt}}c}
    \tabulartext{$n\in\N$}
      &0 &1 &2 &3 &4 &5 &\ldots 
      \\ \cline{2-8}
    \tabulartext{$\sequence{i,j}\in\set{0,1}\times\N$}
      &\sequence{0,0} \rule{0em}{2ex} % make room above angle brackets
      &\sequence{1,0}
      &\sequence{0,1}
      &\sequence{1,1}
      &\sequence{0,2}
      &\sequence{1,2}
      &\ldots
  \end{array}
\end{equation*}
Where $p$ is the pairing function and $u$ is the unpairing function,
find these.
\begin{parts}
\part $p(12)$, $p(103)$
\part $u(0,5)$, $u(1,324)$
\part Give a formula for $u(i,j)$.
\end{parts}
\begin{solution}
\begin{parts}
\part Numbers that are even, $2x$, are associated with a pair 
  $\sequence{i,j}$ with $i=0$ and $j=x$.
  Numbers that are odd $2x+1$ are associated with $\sequence{1,x}$.
  So $p(12)=\sequence{0,6}$ and $p(103)=\sequence{1,51}$.
\part
  Taking the observation from the prior part in reverse, 
  $u(0,5)=10$ and $u(1,324)=649$.
\part $u(i,j)=2j+i$
\end{parts}
\end{solution}


\question
Consider the correspondence between $\N$ and $\set{0,1,2}\times\N$
like the one in the book between $\N$ and $\set{0,1}\times\N$.
\begin{parts}
\part Draw the set $\set{0,1,2}\times\N$.
\part
Fill in this table.
\begin{equation*}
  \begin{array}{r|cccccc@{\hspace{6pt}}c}
    \tabulartext{$n\in\N$}
      &0 &1 &2 &3 &4 &5 &\ldots 
      \\ \cline{2-8}
    \tabulartext{$\sequence{i,k}\in\set{0,1,2}\times\N$}
      & \rule{0em}{2ex} % make room above angle brackets
      &
      &
      &
      &
      &
      &\ldots
  \end{array}
\end{equation*}
\end{parts}
\begin{solution}
\begin{parts}
\part
\begin{equation*}
\begin{array}{ccc}
  \vdots         &\vdots         &\vdots          \\
  \sequence{0,4} &\sequence{1,4} &\sequence{2,4}  \\
  \sequence{0,3} &\sequence{1,3} &\sequence{2,3}  \\
  \sequence{0,2} &\sequence{1,2} &\sequence{2,2}  \\
  \sequence{0,1} &\sequence{1,1} &\sequence{2,1}  \\
  \sequence{0,0} &\sequence{1,0} &\sequence{2,0}  \\
\end{array}
\end{equation*}
\part
By simply counting across and then up
we get these table entries.
\begin{equation*}
  \begin{array}{r|cccccc@{\hspace{6pt}}c}
    \tabulartext{$n\in\N$}
      &0 &1 &2 &3 &4 &5 &\ldots 
      \\ \cline{2-8}
    \tabulartext{$\sequence{i,k}\in\set{0,1,2}\times\N$}
      &\sequence{0,0} \rule{0em}{2ex} % make room above angle brackets
      &\sequence{0,1}
      &\sequence{0,2}
      &\sequence{1,0}
      &\sequence{1,1}
      &\sequence{1,2}
      &\ldots
  \end{array}
\end{equation*}
\end{parts}
\end{solution}


\question
Consider Cantor's correspondence between $\N$ and $\N^2$.
\begin{equation*}
  \begin{array}{cccccc}
    \vdots          &\vdots         &\vdots         &\vdots         \\
    \sequence{0,3}  &\sequence{1,3} &\sequence{2,3} &\sequence{3,3} &\cdots  \\
    \sequence{0,2}  &\sequence{1,2} &\sequence{2,2} &\sequence{3,2} &\cdots  \\ 
    \sequence{0,1}  &\sequence{1,1} &\sequence{2,1} &\sequence{3,1} &\cdots  \\ 
    \sequence{0,0}  &\sequence{1,0} &\sequence{2,0} &\sequence{3,0} &\cdots
  \end{array}
\end{equation*}
as given in this table.
\begin{center}
  \begin{tabular}{r|ccccccc@{\hspace{6pt}}c}
    \tabulartext{Number}  
       &$0$    &$1$   &$2$  &$3$  &$4$  &$5$  &$6$ &\ldots   
   \\ \cline{2-9}
    \tabulartext{Pair} 
               &$\sequence{0,0}$  
               &$\sequence{0,1}$ 
               &$\sequence{1,0}$ 
               &$\sequence{0,2}$  
               &$\sequence{1,1}$ 
               &$\sequence{2,0}$ 
               &$\sequence{0,3}$  
               &\ldots 
     \end{tabular}
\end{center}
Let $p$ be the pairing function, and let $\cantor$ be the unpairing function.
\begin{parts}
\part Find $p(10)$ and $p(30)$.
\part Find $\cantor(5,0)$, $\cantor(6,0)$, and $\cantor(3,3)$.
\end{parts}
\begin{solution}
Here is some of the correspondence.
\begin{equation*}
\begin{array}{c|*{8}{c}}
  7 &28 & & & & & & &  \\
  6 &21 &29 & & & & &  \\
  5 &15 &22 &30 & & & & &  \\
  4 &10 &16 &23 & & & & &  \\
  3 &6 &11 &17 &24 & & & &  \\
  2 &3 &7 &12 &18 &25 & & &  \\
  1 &1 &4 &8 &13 &19 &26 & &  \\
  0 &0 &2 &5 &9 &14 &20 &27 &  \\
  \cline{2-9}
  \multicolumn{1}{c}{\ } &0 &1 &2 &3 &4 &5 &6 &7   \\
\end{array}
\end{equation*}
\begin{parts}
\part $p(10)=\sequence{0,4}$, $p(30)=\sequence{2,5}$
\part $\cantor(5,0)=20$, $\cantor(6,0)=27$, $\cantor(3,3)=24$
\end{parts}
\end{solution}


\question
Fill in this table with the natural correspondence between $\N$
and $\set{0,1}\times \N^2$.
\begin{center}
  \begin{tabular}{r|ccccccc@{\hspace{6pt}}c}
    \tabulartext{Number}  
       &$0$    &$1$   &$2$  &$3$  &$4$  &$5$  &$6$ &\ldots   
   \\ \cline{2-9}
    \tabulartext{Triple} 
               &  
               & 
               & 
               &  
               & 
               & 
               &  
               &\ldots 
     \end{tabular}
\end{center}
\begin{solution}
\begin{center}
  \begin{tabular}{r|ccccccc@{\hspace{6pt}}c}
    \tabulartext{Number}  
       &$0$    &$1$   &$2$  &$3$  &$4$  &$5$  &$6$ &\ldots   
   \\ \cline{2-9}
    \tabulartext{Triple} 
               &$\sequence{0,0,0}$  
               &$\sequence{1,0,0}$  
               &$\sequence{0,0,1}$ 
               &$\sequence{1,0,1}$ 
               &$\sequence{0,1,0}$ 
               &$\sequence{1,1,0}$ 
               &\ldots 
     \end{tabular}
\end{center}
\end{solution}

\end{questions}
\end{document}
